#[doc = "Register `LPTIM_CR` reader"]
pub struct R(crate::R<LPTIM_CR_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<LPTIM_CR_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<LPTIM_CR_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<LPTIM_CR_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `LPTIM_CR` writer"]
pub struct W(crate::W<LPTIM_CR_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<LPTIM_CR_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<LPTIM_CR_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<LPTIM_CR_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `ENABLE` reader - ENABLE"]
pub type ENABLE_R = crate::BitReader<bool>;
#[doc = "Field `ENABLE` writer - ENABLE"]
pub type ENABLE_W<'a, const O: u8> = crate::BitWriter<'a, u32, LPTIM_CR_SPEC, bool, O>;
#[doc = "Field `SNGSTRT` reader - SNGSTRT"]
pub type SNGSTRT_R = crate::BitReader<bool>;
#[doc = "Field `SNGSTRT` writer - SNGSTRT"]
pub type SNGSTRT_W<'a, const O: u8> = crate::BitWriter<'a, u32, LPTIM_CR_SPEC, bool, O>;
#[doc = "Field `CNTSTRT` reader - CNTSTRT"]
pub type CNTSTRT_R = crate::BitReader<bool>;
#[doc = "Field `CNTSTRT` writer - CNTSTRT"]
pub type CNTSTRT_W<'a, const O: u8> = crate::BitWriter<'a, u32, LPTIM_CR_SPEC, bool, O>;
#[doc = "Field `COUNTRST` reader - COUNTRST"]
pub type COUNTRST_R = crate::BitReader<bool>;
#[doc = "Field `COUNTRST` writer - COUNTRST"]
pub type COUNTRST_W<'a, const O: u8> = crate::BitWriter<'a, u32, LPTIM_CR_SPEC, bool, O>;
#[doc = "Field `RSTARE` reader - RSTARE"]
pub type RSTARE_R = crate::BitReader<bool>;
#[doc = "Field `RSTARE` writer - RSTARE"]
pub type RSTARE_W<'a, const O: u8> = crate::BitWriter<'a, u32, LPTIM_CR_SPEC, bool, O>;
impl R {
    #[doc = "Bit 0 - ENABLE"]
    #[inline(always)]
    pub fn enable(&self) -> ENABLE_R {
        ENABLE_R::new((self.bits & 1) != 0)
    }
    #[doc = "Bit 1 - SNGSTRT"]
    #[inline(always)]
    pub fn sngstrt(&self) -> SNGSTRT_R {
        SNGSTRT_R::new(((self.bits >> 1) & 1) != 0)
    }
    #[doc = "Bit 2 - CNTSTRT"]
    #[inline(always)]
    pub fn cntstrt(&self) -> CNTSTRT_R {
        CNTSTRT_R::new(((self.bits >> 2) & 1) != 0)
    }
    #[doc = "Bit 3 - COUNTRST"]
    #[inline(always)]
    pub fn countrst(&self) -> COUNTRST_R {
        COUNTRST_R::new(((self.bits >> 3) & 1) != 0)
    }
    #[doc = "Bit 4 - RSTARE"]
    #[inline(always)]
    pub fn rstare(&self) -> RSTARE_R {
        RSTARE_R::new(((self.bits >> 4) & 1) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - ENABLE"]
    #[inline(always)]
    pub fn enable(&mut self) -> ENABLE_W<0> {
        ENABLE_W::new(self)
    }
    #[doc = "Bit 1 - SNGSTRT"]
    #[inline(always)]
    pub fn sngstrt(&mut self) -> SNGSTRT_W<1> {
        SNGSTRT_W::new(self)
    }
    #[doc = "Bit 2 - CNTSTRT"]
    #[inline(always)]
    pub fn cntstrt(&mut self) -> CNTSTRT_W<2> {
        CNTSTRT_W::new(self)
    }
    #[doc = "Bit 3 - COUNTRST"]
    #[inline(always)]
    pub fn countrst(&mut self) -> COUNTRST_W<3> {
        COUNTRST_W::new(self)
    }
    #[doc = "Bit 4 - RSTARE"]
    #[inline(always)]
    pub fn rstare(&mut self) -> RSTARE_W<4> {
        RSTARE_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "LPTIM control register\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [lptim_cr](index.html) module"]
pub struct LPTIM_CR_SPEC;
impl crate::RegisterSpec for LPTIM_CR_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [lptim_cr::R](R) reader structure"]
impl crate::Readable for LPTIM_CR_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [lptim_cr::W](W) writer structure"]
impl crate::Writable for LPTIM_CR_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets LPTIM_CR to value 0"]
impl crate::Resettable for LPTIM_CR_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
